// SayHello.java
//
// Server side entity for the HelloWorld service.
//

import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;

public class SayHello extends HelloWorld._SayHelloImplBase {

  static ORB orbRef;

  public String sayhello(String name) {
    return "Hello, "+name+" !";
  }

  public static void main(String[] args) {

    try {
      // The object used for waiting for the clients
      java.lang.Object deadlock = new java.lang.Object();

      orbRef = ORB.init(args, null); // We create the ORB object
      SayHello neoRef = new SayHello(); // Server object
      orbRef.connect(neoRef); // We connect the object to the ORB software

      org.omg.CORBA.Object  ncObjRef =
               orbRef.resolve_initial_references("NameService");
      NamingContext ncRef = NamingContextHelper.narrow(ncObjRef);
      NameComponent nc = new NameComponent("SayHello","srv");
      NameComponent path[] = { nc };
      ncRef.rebind(path,neoRef);

      synchronized (deadlock) { // Waiting for the clients
        deadlock.wait();
      }
    } catch (Exception e) {
      System.out.println("Exception occurred: "+e.getMessage()+"("+e+")");
    }
  }
}
