// MSQLDATABASE.java
//
// Server side application.
//

import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import java.net.URL;
import java.sql.*;

public class MSQLDatabase extends MSQL._DatabaseImplBase {

  String nevem;
  static ORB orbRef;
  Connection con;

   public MSQLDatabase(String s) {
     nevem=s;
   }


   public MSQL.Statement init(String DBURL, String Userid, String Password) 
            throws MSQL.DBCONNECTERROR {
    try {
      Class.forName("com.imaginary.sql.msql.MsqlDriver");
      String url = DBURL;
      con = DriverManager.getConnection(url, Userid, Password);
      MSQLStatement neoRef = new MSQLStatement(orbRef, con, "ST1"); // New object
      orbRef.connect(neoRef); 

      return neoRef;
    }
    catch( Exception exc ) {
      System.out.println(exc.getMessage());
      throw new MSQL.DBCONNECTERROR();
    }
   }

  public int close() 
  {
    try {
      con.close();
    } catch (Exception e) { };
    return 1;
  }

  public static void main(String[] args) {

    try {
      java.lang.Object holtpont = new java.lang.Object();

      orbRef = ORB.init(args, null); // Create ORB ref.
      MSQLDatabase neoRef = new MSQLDatabase("DB1"); // New object
      orbRef.connect(neoRef); 
      org.omg.CORBA.Object  ncObjRef =
               orbRef.resolve_initial_references("NameService");
      NamingContext ncRef = NamingContextHelper.narrow(ncObjRef);
      NameComponent nc = new NameComponent("MSQL","srv");
      NameComponent path[] = { nc };
      ncRef.rebind(path,neoRef);

      String szovegesref=orbRef.object_to_string(neoRef);
      System.out.println("RootRef:"+szovegesref);
      System.err.println(szovegesref);

      synchronized (holtpont) { // Wait forever
        holtpont.wait(); 
      }
    } catch (Exception e) {
      System.out.println("Exception: "+e.getMessage());
    }
  }
}



















/*


// MSQLTest.java
//
// Teszteli a MiniSQL adatbzis-kapcsolatot.


class MSQLTest {
  public static void main(String argv[]) {
    try {
      Statement utas = con.createStatement();
      ResultSet rs = utas.executeQuery("SELECT * FROM Szemelyek ORDER BY Nev");
      ResultSetMetaData oszi = rs.getMetaData();
      System.out.println("Az eredmny oszlopainak szma:"+oszi.getColumnCount());
      for (int i=1;i<=oszi.getColumnCount();i++) {
        System.out.print(i+". oszlop ajnlott fejlce:"+oszi.getColumnName(i));
        System.out.print("  tipusa:"+oszi.getColumnTypeName(i));
        if (oszi.isNullable(i)==ResultSetMetaData.columnNoNulls) {
          System.out.print(" (NOT NULL) ");
        }
        System.out.print("\n");
      }

      System.out.println("Az eredmny sorai:");
      while(rs.next()) {
        int KorEgyevmulva = rs.getInt("Eletkor")+1;
        String KorSzovegesen = rs.getString("Eletkor");
        String Nev = rs.getString("Nev");

        System.out.print("Nv: " + Nev);
        System.out.print("   letkor: " + KorSzovegesen);
        System.out.print("   letkor 1 v mlva: " + (KorEgyevmulva));
        System.out.print("\n");
      }
      utas.close();
      System.out.println();
      DatabaseMetaData dd = con.getMetaData();
      rs = dd.getTables(null, null, null, null);
      while( rs.next() ) {
        System.out.println("Tbla neve: " + rs.getString("TABLE_NAME") + 
            "  tpusa: " + rs.getString("TABLE_TYPE") );
      }
      con.close();
    }
    catch( Exception exc ) {
      System.out.println(exc.getMessage());
    }
  }
}
*/
